%global commitId 78636f3e1f72a9ee54ffc3b57109215901658008

%global stable_version 1.18.0
%global prerel_version 0.39b0
%global prerel_distinfo %{prerel_version}.dist-info

%global prerel_pkgdirs %{shrink:
    opentelemetry-instrumentation
    opentelemetry-distro
    instrumentation/opentelemetry-instrumentation-django
    instrumentation/opentelemetry-instrumentation-wsgi
    util/opentelemetry-util-http}

%if 0%{?rhel} == 8
%global component_prefix 3x
%endif

Name:           python%{?component_prefix}-opentelemetry-contrib
Version:        %{stable_version}
Release:        4%{?dist}
Summary:        OpenTelemetry instrumentation for Python modules

License:        Apache-2.0 AND BSD-3-Clause
URL:            https://github.com/open-telemetry/opentelemetry-python-contrib
Source0:        opentelemetry-python-contrib-78636f3e1f72a9ee54ffc3b57109215901658008.tar.gz
BuildArch:      noarch

BuildRequires:  python%{python3_pkgversion}-devel
BuildRequires:  python%{python3_pkgversion}-hatchling
BuildRequires:  python%{python3_pkgversion}-pip
BuildRequires:  python%{python3_pkgversion}-rpm-macros

%description
The Python auto-instrumentation libraries for OpenTelemetry


%package -n python%{python3_pkgversion}-opentelemetry-distro
Summary:        OpenTelemetry Python Distro
Version:        %{prerel_version}

Requires:       python%{python3_pkgversion}-opentelemetry-api >= 1.12
Requires:       python%{python3_pkgversion}-opentelemetry-api < 2
Requires:       python%{python3_pkgversion}-opentelemetry-instrumentation = %{prerel_version}-%{release}
Requires:       python%{python3_pkgversion}-opentelemetry-sdk >= 1.13
Requires:       python%{python3_pkgversion}-opentelemetry-sdk < 2

%description -n python%{python3_pkgversion}-opentelemetry-distro
This package provides entrypoints to configure OpenTelemetry.


%package -n python%{python3_pkgversion}-opentelemetry-distro+otlp
Summary:        Metapackage for OpenTelemetry otlp extras
Version:        %{prerel_version}

Requires:       python%{python3_pkgversion}-opentelemetry-distro = %{prerel_version}-%{release}
Requires:       python%{python3_pkgversion}-opentelemetry-exporter-otlp = %{stable_version}

%description -n python%{python3_pkgversion}-opentelemetry-distro+otlp
This is a metapackage bringing in “otlp” extras requires for
python3-opentelemetry-distro. It makes sure the dependencies are installed.

%files -n python%{python3_pkgversion}-opentelemetry-distro+otlp
%ghost %{python3_sitelib}/opentelemetry_distro-%{prerel_version}.dist-info


%package -n python%{python3_pkgversion}-opentelemetry-instrumentation
Summary:        Instrumentation Tools & Auto Instrumentation for OpenTelemetry Python
Version:        %{prerel_version}
License:        Apache-2.0

Requires:       python%{python3_pkgversion}-opentelemetry-api >= 1.4
Requires:       python%{python3_pkgversion}-opentelemetry-api < 2
Requires:       python%{python3_pkgversion}-setuptools >= 16.0
Requires:       python%{python3_pkgversion}-wrapt >= 1.0.0
Requires:       python%{python3_pkgversion}-wrapt < 2.0.0

%description -n python%{python3_pkgversion}-opentelemetry-instrumentation
This package provides a couple of commands that help automatically instruments
a program.


%package -n python%{python3_pkgversion}-opentelemetry-instrumentation-django
Summary:        OpenTelemetry Instrumentation for Django
Version:        %{prerel_version}
License:        Apache-2.0

Requires:       python%{python3_pkgversion}-opentelemetry-api >= 1.12
Requires:       python%{python3_pkgversion}-opentelemetry-api < 2
Requires:       python%{python3_pkgversion}-opentelemetry-instrumentation = %{prerel_version}-%{release}
Requires:       python%{python3_pkgversion}-opentelemetry-instrumentation-wsgi = %{prerel_version}-%{release}
Requires:       python%{python3_pkgversion}-opentelemetry-semantic-conventions = %{prerel_version}
Requires:       python%{python3_pkgversion}-opentelemetry-util-http = %{prerel_version}-%{release}

%description -n python%{python3_pkgversion}-opentelemetry-instrumentation-django
This library allows tracing requests for Django applications.


%package -n python%{python3_pkgversion}-opentelemetry-instrumentation-wsgi
Summary:        %{summary}
Version:        %{prerel_version}
License:        Apache-2.0

Requires:       python%{python3_pkgversion}-opentelemetry-api >= 1.12
Requires:       python%{python3_pkgversion}-opentelemetry-api < 2
Requires:       python%{python3_pkgversion}-opentelemetry-instrumentation = %{prerel_version}-%{release}
Requires:       python%{python3_pkgversion}-opentelemetry-semantic-conventions = %{prerel_version}
Requires:       python%{python3_pkgversion}-opentelemetry-util-http = %{prerel_version}-%{release}

%description -n python%{python3_pkgversion}-opentelemetry-instrumentation-wsgi
This library provides a WSGI middleware that can be used on any WSGI framework
(such as Django / Flask) to track requests timing through OpenTelemetry.}


%package -n  python%{python3_pkgversion}-opentelemetry-util-http
Summary:        Web util for OpenTelemetry
Version:        %{prerel_version}

%description -n python%{python3_pkgversion}-opentelemetry-util-http
This library provides ASGI, WSGI middleware and other HTTP-related
functionality that is common to instrumented web frameworks (such as Django,
Starlette, FastAPI, etc.) to track requests timing through OpenTelemetry.


%prep
%autosetup -n opentelemetry-python-contrib-%{commitId}

%build
for pkgdir in %{prerel_pkgdirs}
do
  pushd "${pkgdir}"
    %{__python3} -m pip wheel --wheel-dir %{_builddir}/wheeldir --no-deps --use-pep517 --no-build-isolation --disable-pip-version-check --no-clean --progress-bar off --verbose .
  popd
done

%install
for pkgdir in %{prerel_pkgdirs}
do
  module_name=${pkgdir#*/}
  pushd "${pkgdir}"
    %{__python3} -m pip install --root %{buildroot} --no-deps --disable-pip-version-check --progress-bar off --verbose --ignore-installed --no-warn-script-location --no-index --no-cache-dir --find-links %{_builddir}/wheeldir ${module_name}==%{prerel_version}
  popd
  for distinfo in %{buildroot}/%{python3_sitelib}/*.dist-info
  do
    sed -i 's/pip/rpm/' ${distinfo}/INSTALLER
    rm -fv ${distinfo}/{RECORD,REQUESTED}
  done
done


%files -n python%{python3_pkgversion}-opentelemetry-instrumentation
%license opentelemetry-instrumentation/LICENSE
%doc opentelemetry-instrumentation/README.rst

# Shared namespace directories
%dir %{python3_sitelib}/opentelemetry/{,instrumentation/}

%{python3_sitelib}/opentelemetry/instrumentation/py.typed
%dir %{python3_sitelib}/opentelemetry/instrumentation/__pycache__/
%pycached %{python3_sitelib}/opentelemetry/instrumentation/*.py
%{python3_sitelib}/opentelemetry/instrumentation/auto_instrumentation/
%{python3_sitelib}/opentelemetry_instrumentation-%{prerel_distinfo}/

%{_bindir}/opentelemetry-bootstrap
%{_bindir}/opentelemetry-instrument


%files -n python%{python3_pkgversion}-opentelemetry-distro
%license LICENSE LICENSE.Apache LICENSE.BSD3
%doc opentelemetry-distro/README.rst

# Shared namespace directories
%dir %{python3_sitelib}/opentelemetry/

%{python3_sitelib}/opentelemetry/distro/
%{python3_sitelib}/opentelemetry_distro-%{prerel_distinfo}/


%files -n python%{python3_pkgversion}-opentelemetry-util-http
%license LICENSE LICENSE.Apache LICENSE.BSD3
%doc util/opentelemetry-util-http/README.rst

# Shared namespace directories
%dir %{python3_sitelib}/opentelemetry/{,util/}

%{python3_sitelib}/opentelemetry/util/http/
%{python3_sitelib}/opentelemetry_util_http-%{prerel_distinfo}/


%files -n python%{python3_pkgversion}-opentelemetry-instrumentation-django
%license instrumentation/opentelemetry-instrumentation-django/LICENSE
%doc instrumentation/opentelemetry-instrumentation-django/README.rst

# Shared namespace directories
%dir %{python3_sitelib}/opentelemetry/{,instrumentation/}

%{python3_sitelib}/opentelemetry/instrumentation/django/
%{python3_sitelib}/opentelemetry_instrumentation_django-%{prerel_distinfo}/


%files -n python%{python3_pkgversion}-opentelemetry-instrumentation-wsgi
%doc instrumentation/opentelemetry-instrumentation-wsgi/README.rst
%license instrumentation/opentelemetry-instrumentation-wsgi/LICENSE

# Shared namespace directories
%dir %{python3_sitelib}/opentelemetry/{,instrumentation/}

%{python3_sitelib}/opentelemetry/instrumentation/wsgi
%{python3_sitelib}/opentelemetry_instrumentation_wsgi-%{prerel_distinfo}/


%changelog
* Mon Jul 10 2023 Satoe Imaishi <simaishi@redhat.com> - 1.18.0-4
- Initial Build
